//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.doclet;

import com.sun.javadoc.*;

public final class Utility {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/doclet/Utility.java,v $ $revision$ $Date: 1998/11/02 15:54:49 $ Copyright 1998 INRIA.";

    private Utility() {
	super();
    }

    public final static int filter(int aLevel, Doc[] theDatas) {
	final int theSize = theDatas.length;
	int theCounter = 0;
	int theCurrentRank = 0;
	int theLastRank = theSize - 1;
	while ( theCurrentRank <= theLastRank ) {
	    if ( filter(aLevel,theDatas[theCurrentRank])  ) {
		theDatas[theCurrentRank] = theDatas[theLastRank];
		theCounter++;
		theDatas[theLastRank] = null;
		theLastRank--;
	    }
	    else {
		theCurrentRank++;
	    }
	}
	return theCounter;
    }

    public final static boolean filter(int aLevel, Doc aData) {
	final Tag[] theTags = aData.tags(Constants.TAG_LEVEL);
	if ( theTags.length > 0 ) {
	    if ( parseLevel(theTags[0].text()) > aLevel ) {
		return true ;
	    }
	}
	return false;
    }
    
    public final static Doc[] quickSort (Doc[] data,int left,int right) { 
	Doc mid,tmp; 
	int original_left=left; 
	int original_right=right; 
	mid=data[(left+right)/2]; 
	do { 
	    while(data[left].compareTo(mid) < 0) { 
		left++; 
	    } 
	    while (mid.compareTo(data[right]) < 0) { 
		right--; 
	    } 
	    if (left<=right) { 
		tmp=data[left]; 
		data[left]=data[right]; 
		data[right]=tmp; 
		left++; 
		right--; 
	    } 
	} while (left<=right); 
	if (original_left<right) data=quickSort(data,original_left,right); 
	if (left<original_right) data=quickSort(data,left,original_right); 
	return data; 
    }

    public final static String[] quickSort (String[] data,int left,int right) { 
	String mid,tmp; 
	int original_left=left; 
	int original_right=right; 
	mid=data[(left+right)/2]; 
	do { 
	    while(data[left].compareTo(mid) < 0) { 
		left++; 
	    } 
	    while (mid.compareTo(data[right]) < 0) { 
		right--; 
	    } 
	    if (left<=right) { 
		tmp=data[left]; 
		data[left]=data[right]; 
		data[right]=tmp; 
		left++; 
		right--; 
	    } 
	} while (left<=right); 
	if (original_left<right) data=quickSort(data,original_left,right); 
	if (left<original_right) data=quickSort(data,left,original_right); 
	return data; 
    }

    public final static int parseLevel(String aString) {
	if ( aString != null ) {
	    if ( aString.equalsIgnoreCase(Constants.KEYWORD_END_USER) ) {
		return Constants.LEVEL_END_USER;
	    }
	    else {
		if ( aString.equalsIgnoreCase(Constants.KEYWORD_ADVANCED_USER) ) {
		    return Constants.LEVEL_ADVANCED_USER;
		}
		else {
		    if ( aString.equalsIgnoreCase(Constants.KEYWORD_DEVELOPPER) ) {
			return Constants.LEVEL_DEVELOPPER;
		    }
		    else {
			System.out.println("*** Warning *** unknown level " +
					   aString);
		    }
		}
	    }
	}
	return Constants.LEVEL_END_USER;
    }
    
}
