//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.error;

/**
 * [PENDING: update the comments] ErrorHandler.
 */

public abstract class ErrorHandler implements ErrorHandlerInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/error/ErrorHandler.java,v $ $revision$ $Date: 1998/11/02 15:54:51 $ Copyright 1998 INRIA.";

    protected ErrorHandler() {
    }
    
    public final void reportError(Error anError) {
	if ( canHandleError() ) {
	    handleError(anError);
	}
	else {
	    if ( hasNextErrorHandler() ) {
		getNextErrorHandler().reportError(anError);
	    }
	    else {
		if ( DefaultErrorHandler.DEFAULT != null ) {
		    DefaultErrorHandler.DEFAULT.reportError(anError);
		}
		else {
		    DefaultErrorHandler.INSTANCE.reportError(anError);
		}
	    }      
	}
    }
    
    public final void handleError(Error anError) {
	anError.managedBy(this);
    }
    
    public void manageFatalError(Error anError) {
	reportError(new ShouldNotBeCalledError());
    }
    
    public void manageWarning(Warning aWarning) {
	reportError(new ShouldNotBeCalledError());
    }
    
}

