//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.format;

import figue.box.GlyphInterface;

public final class ActionNone extends Action {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/format/ActionNone.java,v $ $revision$ $Date: 1998/11/02 15:54:58 $ Copyright 1998 INRIA.";
  
    private ActionNone() {
	super("None",
	      true, // Better than none ?
	      false, // Better than shrink ?
	      false, // Better than shrink son ?
	      false); // Better than new line ?
    }

    public final void execute(GlyphInterface aGlyph,
			      DecalageInterface aDecalage,
			      AlternativeInterface anAlternative)
	throws TooSmallPageException, StopFormattingSonsException {
	throw TooSmallPageException.INSTANCE;
    }

    public final boolean isComplient(GlyphInterface aGlyph) {
	return aGlyph.isActionNoneComplient();
    }
  
    public final boolean isBetterThan(ActionInterface anAction) {
	return ( ! anAction.isBetterThanNone(this) );
    }

    public final static ActionNone INSTANCE = new ActionNone();
  
}
