//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.format;

import figue.box.GlyphInterface;
import figue.geometry.Dimension;
import figue.geometry.Size;

public interface FormatStatusInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/format/FormatStatusInterface.java,v $ $revision$ $Date: 1998/11/02 15:55:02 $ Copyright 1998 INRIA.";

    public boolean isClean();
    public boolean isProceed();
    public boolean isDirty();
    public boolean isUnstable();
    public boolean isNew();
    public Size getCurrentSize();
    public boolean setCurrentSizeAndCheckAwake(Size aSize);
    public boolean improveEstimatedHeightAndCheckAwake(int anHeight);
    public void setEstimatedSize(Dimension aSize);
    public Dimension expandEstimatedSize(int aWidth, int aHeight);
    public Dimension getEstimatedSize(GlyphInterface aGlyph);
  
}
