//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.format;

import figue.internal.ContextInterface;
import figue.box.GlyphInterface;

public abstract class StrategyImproveSizeEstimation {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/format/StrategyImproveSizeEstimation.java,v $ $revision$ $Date: 1998/11/02 15:55:07 $ Copyright 1998 INRIA.";
  
    protected StrategyImproveSizeEstimation() {
	;
    }
  
    public abstract void doAlgorithm(ContextInterface aContext,
				     GlyphInterface aGlyph,
				     int aRank);


    public final static StrategyImproveSizeEstimation INACTIVE = new StrategyImproveSizeEstimationQuiet();
 
    public final static StrategyImproveSizeEstimation ACTIVE = new StrategyImproveSizeEstimationActive();
  
}

final class StrategyImproveSizeEstimationQuiet extends StrategyImproveSizeEstimation {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/format/StrategyImproveSizeEstimation.java,v $ $revision$ $Date: 1998/11/02 15:55:07 $ Copyright 1998 INRIA.";
  
    public final void doAlgorithm(ContextInterface aContext,
				  GlyphInterface aGlyph,
				  int aRank) {
    }

}

final class StrategyImproveSizeEstimationActive extends StrategyImproveSizeEstimation {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/format/StrategyImproveSizeEstimation.java,v $ $revision$ $Date: 1998/11/02 15:55:07 $ Copyright 1998 INRIA.";
  
    public final void doAlgorithm(ContextInterface aContext,
				  GlyphInterface aGlyph,
				  int aRank) {
	if ( aGlyph.improveEstimatedHeightAndCheckAwake(aGlyph.getChild(aRank).getSizeValue().getHeight()) ) {
	    aGlyph.improveSizeEstimationAndUpdateParents(aContext,aRank);
	}
    }

}
