//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.geometry;

import java.lang.Math;

/**
 * [PENDING: update the comments] Dimension.
 */

public class Dimension extends Rectangle {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/geometry/Dimension.java,v $ $revision$ $Date: 1998/11/02 15:55:09 $ Copyright 1998 INRIA.";
  
    public Dimension(int ulx, int uly, int brx, int bry) { 
	super(-ulx,-uly,ulx + brx,uly + bry);
    }
    public Dimension(int uly, int brx, int bry) { 
	super(0,-uly,brx,uly + bry);
    }
    public Dimension() { 
	super(); 
    }
    public Dimension(Dimension aDimension) { 
	super(aDimension); 
    }
  
    public final int getUpperLeftX() { 
	return -getX(); 
    }
    public final void setUpperLeftX(int ulx) { 
	setX(-ulx); 
    }
    public final int getUpperLeftY() { 
	return -getY(); 
    }
    public final void setUpperLeftY(int uly) { 
	setY(-uly); 
    }
    public final int getBottomRightX() { 
	return getX() + getWidth(); 
    }
    public final void setBottomRightX(int brx) { 
	setWidth(brx - getX()); 
    }
    public final int getBottomRightY() { 
	return getY() + getHeight(); 
    }
    public final void setBottomRightY(int bry) { 
	setHeight(bry - getY()); 
    }
    public int getExitPointX() { 
	return getBottomRightX(); 
    }
    public int getExitPointY() { 
	return 0; 
    }
    /**
     * [PENDING: update the comments] growToIncludeSizeAt
     * @level advanced
     */
    public final void growToIncludeSizeAt(Dimension aDimension,Point aPoint) {
	final int theX = aPoint.getX();
	final int theY = aPoint.getY();
	setUpperLeftX(Math.max(getUpperLeftX(),
			       aDimension.getUpperLeftX() - theX));
	setUpperLeftY(Math.max(getUpperLeftY(),
			       aDimension.getUpperLeftY() - theY));
	setBottomRightX(Math.max(getBottomRightX(),
				 aDimension.getBottomRightX() + theX));
	setBottomRightY(Math.max(getBottomRightY(),
				 aDimension.getBottomRightY() + theY));
    }

    public String toString() {
	StringBuffer theResult = new StringBuffer("Dimension<");
	internalToString(theResult);
	theResult.append(">");
	return theResult.toString();
    }
  
    protected void internalToString(StringBuffer theResult) {
	theResult.append("in(").append(getUpperLeftX()).append("/")
	    .append(getUpperLeftY()).append("),out(")
	    .append(getExitPointX()).append("/").append(getExitPointY())
	    .append(");").append(getWidth()).append("x").append(getHeight());
    }
  
}
