//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.geometry;

/**
 * [PENDING: update the comments] Position.
 * @level advanced
 */

public abstract class Position {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/geometry/Position.java,v $ $revision$ $Date: 1998/11/02 15:55:10 $ Copyright 1998 INRIA.";
  
    protected Position(int dx, int dy) { 
	_dx = dx; 
	_dy = dy; 
    }
    protected Position() { 
	_dx = 0; 
	_dy = 0; 
    }
    protected Position(Position aPosition) { 
	_dx = aPosition._dx; 
	_dy = aPosition._dy;
    }
  
    public final int getDx() { 
	return _dx; 
    }
    public final void setDx(int dx) { 
	_dx = dx; 
    }
    public final int getDy() { 
	return _dy; 
    }
    public final void setDy(int dy) { 
	_dy = dy; 
    }

    public final void setLocation(Position aPosition) {
	_dx = aPosition._dx;
	_dy = aPosition._dy;
    }
  
    public abstract boolean isRelativeToFather();
  
    public final String toString() {
	StringBuffer theResult = new StringBuffer("Position<");
	theResult.append(_dx).append("/").append(_dy).append(";");
	if ( isRelativeToFather() ) {
	    theResult.append("father>");
	} else {
	    theResult.append("brother>");
	}
	return theResult.toString();
    }

    private int _dx; 
    private int _dy; 

}

  
