//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.geometry;

/**
 * [PENDING: update the comments] Size.
 */

public final class Size extends Dimension {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/geometry/Size.java,v $ $revision$ $Date: 1998/11/02 15:55:11 $ Copyright 1998 INRIA.";
  
    public Size(int ulx, int uly, int brx, int bry, int ox, int oy) { 
	super(ulx,uly,brx,bry);
	_exitX = ox;
	_exitY = oy;
    }
  
    public Size() { 
	super(); 
	_exitX = 0;
	_exitY = 0;
    }
  
    public Size(Size aSize) { 
	super(aSize); 
	_exitX = aSize.getExitPointX();
	_exitY = aSize.getExitPointY();
    }
  
    public final int getExitPointX() { 
	return _exitX;
    }
  
    public final int getExitPointY() { 
	return _exitY;
    }
  
    public final void setExitPointX(int x) {
	_exitX = x;
    }
  
    public final void setExitPointY(int y) { 
	_exitY = y;
    }
  
    public final boolean equals(Object anObject) {
	if ( this == anObject ) {
	    return true;
	}
	if ( ! super.equals(anObject) ) {
	    return false;
	}
	if ( getClass() != anObject.getClass() ) {
	    return false; 
	}
	Size theOtherSize = (Size)anObject;
	if ( ( _exitX != theOtherSize._exitX ) || ( _exitY != theOtherSize._exitY) ) {
	    return false;
	}
	return true;
    }
    
    public String toString() {
	StringBuffer theResult = new StringBuffer("Size<");
	internalToString(theResult);
	theResult.append(">");
	return theResult.toString();
    }
  
    private int _exitX;
    private int _exitY;

}
