//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.internal;

import java.util.Hashtable;

public final class Cursor {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/internal/Cursor.java,v $ $revision$ $Date: 1998/11/02 15:55:13 $ Copyright 1998 INRIA.";

    private Cursor(String aName, int aCursorCode) {
	this(aName,java.awt.Cursor.getPredefinedCursor(aCursorCode));
    }

    private Cursor(String aName, java.awt.Cursor aCursor) {
	_name = aName;
	_cursor = aCursor;
    }

    public final static Cursor newCursor(java.awt.Cursor aCursor) {
	final String theKey = Integer.toString(aCursor.getType());
	if ( ! POOL.containsKey(theKey) ) {
	    POOL.put(theKey,new Cursor(theKey,aCursor));
	}
	return (Cursor)(POOL.get(theKey));
    }
  
    public final java.awt.Cursor getAwtCursor() {
	return _cursor;
    }
    
    public final static Cursor DEFAULT = new Cursor("Default",java.awt.Cursor.DEFAULT_CURSOR);
    public final static Cursor MOVE = new Cursor("Move",java.awt.Cursor.MOVE_CURSOR);
    public final static Cursor TEXT = new Cursor("Text",java.awt.Cursor.TEXT_CURSOR);
    public final static Cursor WAIT = new Cursor("Wait",java.awt.Cursor.WAIT_CURSOR);
    public final static Cursor HAND = new Cursor("Hand",java.awt.Cursor.HAND_CURSOR);
    public final static Cursor CROSS = new Cursor("Cross",java.awt.Cursor.CROSSHAIR_CURSOR);

    private String _name;
    private java.awt.Cursor _cursor;

    private static Hashtable POOL = new Hashtable();
  
}
