//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.internal;

public final class Globals {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/internal/Globals.java,v $ $revision$ $Date: 1998/11/02 15:55:14 $ Copyright 1998 INRIA.";

    private Globals() {
    }

    public final static boolean ROBUST = false;
    public final static boolean DEBUG_MULTI_THREAD = false;
    public final static boolean DEBUG_MULTI_THREAD_OVERVIEW = false;
    public final static boolean DEBUG_FORMAT = false;
    public final static boolean DEBUG_FORMAT_HISTORY = false;

    public final static int DEFAULT_FORMATTING_WIDTH_ASCII = 80;
    public final static int DEFAULT_FORMATTING_WIDTH_PS = 700;
    public final static int DEFAULT_FORMATTING_WIDTH_AWT = 700;
  
    public final static int DEFAULT_FORMATTING_HEIGHT = 80;
  
    public final static int DRAW_THREAD_PRIORITY = java.lang.Thread.NORM_PRIORITY + 2;
    public final static int FORMAT_THREAD_PRIORITY = java.lang.Thread.NORM_PRIORITY + 1;
    public final static int BUILD_THREAD_PRIORITY = java.lang.Thread.NORM_PRIORITY;

    public final static String FIGUE_PACKAGE_NAME = "figue";

    public final static int AUTO_SCROLL_DELAY = 500;
    public final static int AUTO_SCROLL_MARGIN = 30;
    public final static int AUTO_SCROLL_RATE = 50;

    public final static int SCROLLBAR_THICKNESS = 15;

    public final static int SCROLL_UNIT = 12;

    public final static int INSURE_VISIBLE_SPACE_AROUND = 20;
  
    public final static int AWAKE_DRAW_WHEN_FORMAT_HEIGHT = 500; ///900;
  
    public final static float VERY_FAST_ACCESS = (float)0.1;
    public final static float FAST_ACCESS = (float)0.25;
    public final static float MEDIUM_ACCESS = (float)0.5;
  
    public final static int AVERAGE_FONT_NUMBER = 50;
    public final static int AVERAGE_COLOR_NUMBER = 50;
    public final static int AVERAGE_SELECTION_NUMBER = 5;
    public final static int AVERAGE_STYLE_NUMBER = 40;
    public final static int AVERAGE_FLY_WEIGHT_ATOM_NUMBER = 100;
    public final static int AVERAGE_FLY_WEIGHT_ATOM_FONT_NUMBER = 5;
    public final static int AVERAGE_FLY_WEIGHT_DECORATED_ATOM_NUMBER = 50;
    public final static int AVERAGE_FLY_WEIGHT_DECORATED_ATOM_STYLE_NUMBER = 3;

    public final static int FORBIDDEN = 10;
    public final static int BAD = 7;
    public final static int GOOD = 5;
    public final static int BEST = 1;
    public final static int NOT_SEEN = 0;

    public final static int PIXEL_OFFSET_FOR_UNDERLINE = 2;

}
