//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.internal;

import figue.event.PointingEvent;
import figue.geometry.Rectangle;
import figue.error.ErrorHandlerInterface;
import figue.box.GlyphInterface;

import java.awt.Graphics;
import java.awt.Image;
import java.awt.Container;

public interface InteractiveClientInterface extends ErrorHandlerInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/internal/InteractiveClientInterface.java,v $ $revision$ $Date: 1998/11/02 15:55:14 $ Copyright 1998 INRIA.";
    
    public void actionGoHome();
    public void actionGoEnd();
    public void actionGoUp();
    public void actionGoDown();
    public void actionGoLeft();
    public void actionGoRight();
    public void actionGoPageUp();
    public void actionGoPageDown();

    public void beginDrag(PointingEvent anEvent);
    public void drag(PointingEvent anEvent);
    public void endDrag(PointingEvent anEvent);

    public void refresh(Rectangle aRectangle);
    public void refresh();
    public void requestFocus();

    public void insureVisible(Rectangle aMarkedZone);

    public PairGlyphPath getDeepestContains(int x, int y,
                                            GlyphInterface aGlyph,
                                            Rectangle aBoundingBox,
                                            ContextInterface aContext);

    public void touch();
    public Graphics getGraphics();
    public void setCursor(Cursor aCursor);
    public Image createImage(int aWidth,int anHeight);
    public void updateScrollbars();
    public void dispose();
    public Container getParent();
    
}
