//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.internal;

import figue.path.PathInterface;
import figue.path.SelectionPathInterface;
import figue.path.InsertGlyph;
import figue.path.ReplaceGlyph;
import figue.path.RemoveGlyph;
import figue.path.MarkGlyph;
import figue.path.TouchGlyph;
import figue.path.ExtendSelection;
import figue.path.ShrinkSelection;
import figue.path.InverseSelection;
import figue.path.TouchSelection;
import figue.path.MarkStable;
import figue.path.MarkUnstable;
import figue.error.ErrorHandlerInterface;
import figue.box.GlyphInterface;
import figue.FacadeInterface;

public interface PathVisitorInterface extends ErrorHandlerInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/internal/PathVisitorInterface.java,v $ $revision$ $Date: 1998/11/02 15:55:17 $ Copyright 1998 INRIA.";
  
    public void init();
    public void insertGlyph(InsertGlyph anInsertOperation,
			    GlyphInterface aGlyph,
			    SelectionPathInterface aSelectionPath);

    public void insertGlyph(InsertGlyph anInsertOperation,
			    GlyphInterface aGlyph);
  
    public void replaceGlyph(ReplaceGlyph aReplaceOperation,
			     GlyphInterface aGlyph,
			     SelectionPathInterface aSelectionPath);
  
    public void replaceGlyph(ReplaceGlyph aReplaceOperation,
			     GlyphInterface aGlyph);

    public void removeGlyph(RemoveGlyph aRemoveOperation,
			    GlyphInterface aGlyph,
			    SelectionPathInterface aSelectionPath);

    public void removeGlyph(RemoveGlyph aRemoveOperation,
			    GlyphInterface aGlyph);

    public void markGlyph(MarkGlyph aMarkOperation,
			  GlyphInterface aGlyph,
			  SelectionPathInterface aSelectionPath);

    public void markGlyph(MarkGlyph aMarkOperation,
			  GlyphInterface aGlyph);

    public void touchGlyph(TouchGlyph aTouchOperation,
			   GlyphInterface aGlyph,
			   SelectionPathInterface aSelectionPath);
  
    public void touchGlyph(TouchGlyph aTouchOperation,
			   GlyphInterface aGlyph);
  
    public void extendSelection(ExtendSelection anExtendOperation,
				GlyphInterface aGlyph,
				SelectionPathInterface aSelectionPath);

    public void extendSelection(ExtendSelection anExtendOperation,
				GlyphInterface aGlyph);
  
    public void shrinkSelection(ShrinkSelection aShrinkOperation,
				GlyphInterface aGlyph,
				SelectionPathInterface aSelectionPath);

    public void shrinkSelection(ShrinkSelection aShrinkOperation,
				GlyphInterface aGlyph);
  
    public void inverseSelection(InverseSelection anInverseOperation,
				 GlyphInterface aGlyph,
				 SelectionPathInterface aSelectionPath);

    public void inverseSelection(InverseSelection anInverseOperation,
				 GlyphInterface aGlyph);
    
    public void touchSelection(TouchSelection aTouchOperation,
			       GlyphInterface aGlyph,
			       SelectionPathInterface aSelectionPath);
    public void touchSelection(TouchSelection aTouchOperation,
			       GlyphInterface aGlyph);
    
  
    public void down(GlyphInterface aGlyph,
		     SelectionPathInterface aSelectionPath,
		     PathInterface aPath);

    public void down(GlyphInterface aGlyph,PathInterface aPath);

    public void markStable(MarkStable aMarkStableOperation,
			   GlyphInterface aGlyph,
			   SelectionPathInterface aSelectionPath);

    public void markStable(MarkStable aMarkStableOperation,
			   GlyphInterface aGlyph);
  
    public void markUnstable(MarkUnstable aMarkUnstableOperation,
			     GlyphInterface aGlyph,
			     SelectionPathInterface aSelectionPath);

    public void markUnstable(MarkUnstable aMarkUnstableOperation,
			     GlyphInterface aGlyph);

    public void addEmptyLeaf(SelectionPathInterface aLeaf);
  
    public FacadeInterface getFacade();
    public ContextInterface getContext();

}
