//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.internal;

public final class StackAsync implements StackInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/internal/StackAsync.java,v $ $revision$ $Date: 1998/11/02 15:55:17 $ Copyright 1998 INRIA.";
  
    public StackAsync (int anInitialCapacity,
		       int aCapacityIncrement) {
	_capacity = anInitialCapacity;
	_capacityIncrement = aCapacityIncrement;
	_size = 0;
	_topPointer = 0;
	_data = new Object[anInitialCapacity];
    }

    public StackAsync(int anInitialCapacity) {
	this(anInitialCapacity,1);
    }
  
    public StackAsync() {
	this(0,1);
    }

    public final boolean isEmpty() {
	return ( _size == 0 );
    }
  
    public final void push(Object anObject) {
	if ( _size == _capacity ) {
	    grow();
	}
	_data[_topPointer] = anObject;
	_topPointer = ( _topPointer + 1 ) % _capacity;
	_size++;
    }

    private final void grow() {
	final int theOldCapacity = _capacity;
	_capacity += _capacityIncrement;
	Object[] theOldData = _data;
	_data = new Object[_capacity];
	int theOldRank = 0;
	for ( int theRank = 0; theRank < theOldCapacity; theRank++ ) {
	    _data[theRank] = theOldData[theOldRank];
	    theOldRank++;
	}
	_topPointer = theOldCapacity;
    }
  
    public final Object pop() {
	_topPointer = ( _topPointer - 1 + _capacity ) % _capacity;
	Object theResult = _data[_topPointer];
	_data[_topPointer] = null;
	_size--;
	return theResult;
    }
  
    private int _capacityIncrement;
    private int _size;
    private int _topPointer;
    private int _capacity;
    private Object[] _data;
  
}
