//*****************************************************************************
//   Copyright (c) 1998 Bernard Sufrin, Oxford.
//   http://www.comlab.ox.ac.uk/oucl/people/bernard.sufrin.html
//*****************************************************************************

package figue.jape;

public interface BitMapFont extends java.io.Serializable {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/jape/BitMapFont.java,v $ $revision$ $Date: 1998/11/02 15:55:22 $ Copyright 1998, Bernard Sufrin, Oxford.";
    
    /** Design resolution of the font. */
    public int          dpi();
  
    /** Character coded <tt>i</tt> */
    public BitMapChar   getChar(int i);
  
    /** Name of the face */
    public String       name();
  
    /** Construct a scaled font from this one */
    public BitMapFont   scale(int factor); 

    /** Construct a quantized font from this one */
    public BitMapFont   quantize(int bits); 

    /** Maximum character height in the font */
    public int getHeight();  
  
    /** Maximum character ascent (above the baseline)  in the font */
    public int getAscent();  
  
    /** Maximum character descent (below the baseline)  in the font */
    public int getDescent(); 
}









