//*****************************************************************************
//   Copyright (c) 1998 Bernard Sufrin, Oxford.
//   http://www.comlab.ox.ac.uk/oucl/people/bernard.sufrin.html
//*****************************************************************************

package figue.jape;

import  java.awt.Graphics;
import  java.awt.Color;
import  java.awt.Dimension;
/**
        A Font is a TypeFace bound to a particular size
        and particular colours. 
        
        The size and bounding-box information for all fonts
        derived from a given typeface at a given magnification
        will be identical.  
*/


public interface Font extends TypeFace, ColorScheme {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/jape/Font.java,v $ $revision$ $Date: 1998/11/02 15:55:23 $ Copyright 1998, Bernard Sufrin, Oxford.";

    /** Draw the given string at the given position on the given graphics context */
    public void     draw (Graphics gc, String s, int x, int baseline);
    
    /** Dimension of the bounding box of the given String */
    public Dimension getDimension(String characters);
                
    /** Width of the bounding box of the given String */
    public int getWidth(String s);
        
    /** Lines in this font separated by getHeight() will be disjoint */
    public int getHeight();
        
    /** Maximum ascent of a character in the font */
    public int getAscent();
        
    /** Maximum descent of a character in the font */
    public int getDescent();
        
    /** Font leading */
    public int getLeading();
        
    /** 
	Monotonically increasing array containing the right hand edge
	distance of each character in the given string from the origin of
	the string.
    */
    public int[] getBoundaries(String characters);

}


