//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.multithread;

public interface NotifyingThreadStateInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/multithread/NotifyingThreadStateInterface.java,v $ $revision$ $Date: 1998/11/02 15:55:26 $ Copyright 1998 INRIA.";

    public void setState(ThreadStateInterface aState);
    public void changeState(ThreadStateInterface aState);
    public void reportInvalidState();
    public boolean isDone();
    public boolean isInactive() throws StoppedFacadeException;
    public boolean isFormattable() throws StoppedFacadeException;
    public boolean isFormatting() throws StoppedFacadeException;
    public void startFormat();
    public void endFormat();
    public void suspendFormat();
    public boolean isDrawable() throws StoppedFacadeException;
    public boolean isDrawing() throws StoppedFacadeException;
    public void startDraw();
    public void endDraw();
    public boolean isUpdatingGlyph() throws StoppedFacadeException;
    public void startUpdateGlyph();
    public void endUpdateGlyph();
    public boolean isBuilding() throws StoppedFacadeException;
    public boolean isBuildingPhase() throws StoppedFacadeException;
    public void startBuild();
    public void endBuild();
    public void quit();
    public void init();
    public void fatalError();
    public void dispose();
}

