//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.multithread;

public interface ThreadStateInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/multithread/ThreadStateInterface.java,v $ $revision$ $Date: 1998/11/02 15:55:27 $ Copyright 1998 INRIA.";
    
    public boolean isDone();
    public boolean isInactive() throws StoppedFacadeException;
    public boolean isFormattable() throws StoppedFacadeException;
    public boolean isFormatting() throws StoppedFacadeException;
    public void startFormat(NotifyingThreadStateInterface aNotifyingThreadState);
    public void endFormat(NotifyingThreadStateInterface aNotifyingThreadState);
    public void suspendFormat(NotifyingThreadStateInterface aNotifyingThreadState);
    public boolean isDrawable() throws StoppedFacadeException;
    public boolean isDrawing() throws StoppedFacadeException;
    public void startDraw(NotifyingThreadStateInterface aNotifyingThreadState);
    public void endDraw(NotifyingThreadStateInterface aNotifyingThreadState);
    public boolean isUpdatingGlyph() throws StoppedFacadeException;
    public void startUpdateGlyph(NotifyingThreadStateInterface aNotifyingThreadState);
    public void endUpdateGlyph(NotifyingThreadStateInterface aNotifyingThreadState);
    public boolean isBuilding() throws StoppedFacadeException;
    public boolean isBuildingPhase() throws StoppedFacadeException;
    public void startBuild(NotifyingThreadStateInterface aNotifyingThreadState);
    public void endBuild(NotifyingThreadStateInterface aNotifyingThreadState);
    
    public void quit(NotifyingThreadStateInterface aNotifyingThreadState);
    public void init(NotifyingThreadStateInterface aNotifyingThreadState);
    public void fatalError(NotifyingThreadStateInterface aNotifyingThreadState);
    
    public final static ThreadStateInterface INIT = ThreadState.INIT;
    
}
