//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.path;

import figue.selection.SelectionInterface;
import figue.internal.PathVisitorInterface;

/**
 * [PENDING: update the comments] SelectionPathInterface.
 */

public interface SelectionPathInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/path/SelectionPathInterface.java,v $ $revision$ $Date: 1998/11/02 15:55:32 $ Copyright 1998 INRIA.";
  
    public abstract int getRank();
    public SelectionInterface getSelection(int aRank);
    public void addSelection(SelectionInterface aSelection);
    public SelectionPathInterface getParent();
    public int numberOfSelections();
    public void addChild(SelectionPathInterface aChild);
    public SelectionPathInterface getChild(int aRank);
    public void removeChild(SelectionPathInterface aChild);
    public int numberOfChildren();
    public boolean contains(SelectionInterface aSelection);
    public String toString();

    /**
     * [PENDING: update the comments] setParent
     * @level advanced
     */
    public void setParent(SelectionPathInterface aSelectionPath);
    /**
     * [PENDING: update the comments] removeAllSelections
     * @level advanced
     */
    public void removeAllSelections(PathVisitorInterface aVisitor);
    /**
     * [PENDING: update the comments] removeSelection
     * @level advanced
     */
    public void removeSelection(SelectionInterface aSelection,
				PathVisitorInterface aVisitor);
    /**
     * [PENDING: update the comments] inverseSelection
     * @level advanced
     */
    public void inverseSelection(SelectionInterface aSelection,
				 PathVisitorInterface aVisitor);
    /**
     * [PENDING: update the comments] indexOf
     * @level advanced
     */
    public int indexOf(int aRank);
    /**
     * [PENDING: update the comments] search
     * @level advanced
     */
    public SelectionPathInterface search(int aRank);
    /**
     * [PENDING: update the comments] cutEmptyLeaf
     * @level advanced
     */
    public void cutEmptyLeaf(); 
    /**
     * [PENDING: update the comments] internalToString
     * @level advanced
     */
    public void internalToString(StringBuffer aBuffer,String aPath);
  
}
