//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.path;

import figue.internal.PathVisitorInterface;
import figue.box.GlyphInterface;

import java.io.Writer;
import java.io.IOException;

/**
 * [PENDING: update the comments] TouchSelection.
 * @level advanced
 */

public final class TouchSelection implements PathOperationInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/path/TouchSelection.java,v $ $revision$ $Date: 1998/11/02 15:55:33 $ Copyright 1998 INRIA.";
  
    private TouchSelection() {
	super();
    }
  
    public final Object clone() { 
	return this; 
    }

    public final void accept(PathVisitorInterface aVisitor,
			     GlyphInterface aGlyph,
			     SelectionPathInterface aSelectionPath) {
	aVisitor.touchSelection(this,aGlyph,aSelectionPath);
    }

    public final void accept(PathVisitorInterface aVisitor,
			     GlyphInterface aGlyph) {
	aVisitor.touchSelection(this,aGlyph);
    }
  
    public final String toString() { 
	return "TouchSelection<>";
    }

    public final void writeState(Writer anOutput) throws IOException {
	anOutput.write("<TouchSelection/>");
    }
    
    public final static TouchSelection INSTANCE = new TouchSelection();

}
