//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.resource;

/**
 * [PENDING: update the comments] BackgroundInitializer.
 * @level advanced
 */

public final class BackgroundInitializer extends ResourceInitializer implements ColorInitializerInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/resource/BackgroundInitializer.java,v $ $revision$ $Date: 1998/11/02 15:55:34 $ Copyright 1998 INRIA.";
  
    public BackgroundInitializer(BackgroundOwnerInterface anOwner) {
	super();
	_owner = anOwner;
    }

    public final ResourceOwnerInterface getOwner() {
	return _owner;
    }
  
    public final ColorInterface initResource(String aName) {
	ColorInterface theColor = newBackground(_owner,aName);
	_owner.setBackground(theColor);
	return theColor;
    }
  
    public final String getName() {
	return "Background";
    }

    private BackgroundOwnerInterface _owner;
  
}
