//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.resource;

import figue.error.ShouldNotBeCalledError;

import java.io.Writer;
import java.io.IOException;
import figue.io.Utility;

/**
 * [PENDING: update the comments] Color.
 * @level advanced
 */

public abstract class Color implements ColorInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/resource/Color.java,v $ $revision$ $Date: 1998/11/02 15:55:35 $ Copyright 1998 INRIA.";
    
    protected Color(String aName) {
	_name = aName;
    }
    
    public final String getName() {
	return _name;
    }
  
    public java.awt.Color getAwtColor() {
	throw new ShouldNotBeCalledError();
    }

    public final String toString() {
	final StringBuffer theResult = new StringBuffer("Color<");
	if ( getName() != null ) {
	    theResult.append(getName());
	}
	else {
	    theResult.append(getRed()).append('/').append(getGreen())
		.append('/').append(getBlue());
	}
	theResult.append('>');
	return theResult.toString();
    }

    public final void writeState(Writer anOutput) throws IOException {
	anOutput.write("<Color Name=\"");
	Utility.writeStringAsXmlValue(anOutput,getName());
	anOutput.write("\" Red=\"");
	anOutput.write(Integer.toString(getRed()));
	anOutput.write("\" Green=\"");
	anOutput.write(Integer.toString(getGreen()));
	anOutput.write("\" Blue=\"");
	anOutput.write(Integer.toString(getBlue()));
	anOutput.write("\"/>");
    }

    private String _name;
  
}
