//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.resource;

import figue.error.ShouldNotBeCalledError;

import java.io.Writer;
import java.io.IOException;

/**
 * [PENDING: update the comments] FontDefered.
 * @level advanced
 */

public final class FontDefered implements FontInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/resource/FontDefered.java,v $ $revision$ $Date: 1998/11/02 15:55:37 $ Copyright 1998 INRIA.";

    public FontDefered(String aName,
		       FontInitializerInterface aResourceInitializer) {
	_name = aName;
	_resourceInitializer = aResourceInitializer;
    }
  
    public final String getName() {
	return _name;
    }

    public final String getKey() {
	return _resourceInitializer.initResource(_name).getKey();
    }

    public final FontFamily getFamily() {
	return _resourceInitializer.initResource(_name).getFamily();
    }
  
    public final FontStyle getStyle() {
	return _resourceInitializer.initResource(_name).getStyle();
    }
  
    public final int getSize() {
	return _resourceInitializer.initResource(_name).getSize();
    }

    public final boolean isUnderlined() {
	return _resourceInitializer.initResource(_name).isUnderlined();
    }
  
    public final boolean equals(Object anObject) {
	return _resourceInitializer.initResource(_name).equals(anObject);
    }
  
    public final java.awt.Font getAwtFont() {
	return _resourceInitializer.initResource(_name).getAwtFont();
    }
  
    public final String toString() {
	StringBuffer theResult = new StringBuffer("FontDefered<");
	theResult.append(_name).append(">");
	return theResult.toString();
    }

    public void writeState(Writer anOutput) throws IOException {
	throw new ShouldNotBeCalledError();
    }

    private String _name;
    private FontInitializerInterface _resourceInitializer;

}
