//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.resource;

/**
 * [PENDING: update the comments] FontStyle.
 */

public final class FontStyle {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/resource/FontStyle.java,v $ $revision$ $Date: 1998/11/02 15:55:39 $ Copyright 1998 INRIA.";

    final static int ENUM_PLAIN = 0;
    final static int ENUM_ITALIC = ENUM_PLAIN + 1;
    final static int ENUM_BOLD = ENUM_ITALIC + 1;
    final static int ENUM_BOLD_ITALIC = ENUM_BOLD + 1;
  
    public final static FontStyle PLAIN = new FontStyle("Plain",ENUM_PLAIN);
    public final static FontStyle ITALIC = new FontStyle("Italic",ENUM_ITALIC);
    public final static FontStyle BOLD = new FontStyle("Bold",ENUM_BOLD);
    public final static FontStyle BOLD_ITALIC = new FontStyle("BoldItalic",ENUM_BOLD_ITALIC);
  
    private FontStyle(String aName, int anEnum) { 
	_style = aName;
	_enum = anEnum;
    }

    public final String getName() {
	return _style;
    }
    /**
     * [PENDING: update the comments] getEnum
     * @level advanced
     */
    public final int getEnum() {
	return _enum;
    }
  
    public final String toString() {
	return _style;
    }
    /**
     * [PENDING: update the comments] valueOf
     * @level advanced
     */
    public final static FontStyle valueOf(String aName) {
	if ( aName.equalsIgnoreCase("Plain") ) {
	    return PLAIN;
	}
	else {
	    if ( aName.equalsIgnoreCase("Italic") ) {
		return ITALIC;
	    } 
	    else {
		if ( aName.equalsIgnoreCase("Bold") ) {
		    return BOLD;
		}
		else {
		    if ( aName.equalsIgnoreCase("BoldItalic") ) {
			return BOLD_ITALIC;
		    }
		    else {
			return null;
		    }
		}
	    }
	}
    }

    private String _style;
    private int _enum;
    
}
