//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.resource;

import figue.error.ShouldNotBeCalledError;

import java.io.Writer;
import java.io.IOException;

/**
 * [PENDING: update the comments] StyleDefered.
 * @level advanced
 */

public final class StyleDefered implements StyleInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/resource/StyleDefered.java,v $ $revision$ $Date: 1998/11/02 15:55:42 $ Copyright 1998 INRIA.";
    
    public StyleDefered(String aName,
			StyleInitializer aResourceInitializer) {
	_name = aName;
	_resourceInitializer = aResourceInitializer;
    }
  
    public final String getName() {
	return _name;
    }
  
    public final FontInterface getFont() {
	return _resourceInitializer.initResource(_name).getFont();
    }
  
    public final void setFont(FontInterface aFont) {
	_resourceInitializer.initResource(_name).setFont(aFont);
    }
  
    public final ColorInterface getColor() {
	return _resourceInitializer.initResource(_name).getColor();
    }

    public final void setColor(ColorInterface aColor) {
	_resourceInitializer.initResource(_name).setColor(aColor);
    }
  
    public final ColorInterface getBackground() {
	return _resourceInitializer.initResource(_name).getBackground();
    }
  
    public final void setBackground(ColorInterface aColor) {
	_resourceInitializer.initResource(_name).setBackground(aColor);
    }

    public final String toString() {
	StringBuffer theResult = new StringBuffer("StyleDefered<");
	theResult.append(_name).append(">");
	return theResult.toString();
    }

    public void writeState(Writer anOutput) throws IOException {
	throw new ShouldNotBeCalledError();
    }

    private String _name;
    private StyleInitializer _resourceInitializer;

}

