//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.selection; 

import figue.box.GlyphInterface;
import figue.geometry.Dimension;
import figue.geometry.Transformer;
import figue.internal.ContextInterface;
import figue.internal.ContextMementoInterface;

/**
 * [PENDING: update the comments] BarHighlighter.
 */

public final class BarHighlighter extends DefaultHighlighter {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/selection/BarHighlighter.java,v $ $revision$ $Date: 1998/11/02 15:55:43 $ Copyright 1998 INRIA.";

    private BarHighlighter() {
	super();
    }

    protected final void highlightArea(GlyphInterface aGlyph,
				       Dimension aSize,
				       Transformer aTransformer,
				       ContextInterface aContext,
				       ContextMementoInterface aMemento) {
	aContext.fillRectangle(
	     aTransformer.applyToX(aGlyph.getOriginX()) - aSize.getUpperLeftX(),
	     aTransformer.applyToY(aGlyph.getOriginY()) - aSize.getUpperLeftY(),
	     3,
	     aSize.getHeight());
    }

    public final static BarHighlighter INSTANCE = new BarHighlighter();
    
}
