//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.selection; 

import figue.box.GlyphInterface;
import figue.geometry.Dimension;
import figue.geometry.Transformer;
import figue.internal.ContextInterface;
import figue.internal.ContextMementoInterface;

/**
 * [PENDING: update the comments] CornerHighlighter.
 */

public final class CornerHighlighter extends DefaultHighlighter {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/selection/CornerHighlighter.java,v $ $revision$ $Date: 1998/11/02 15:55:44 $ Copyright 1998 INRIA.";

    private CornerHighlighter() {
	super();
    }

    protected final void highlightArea(GlyphInterface aGlyph,
				       Dimension aSize,
				       Transformer aTransformer,
				       ContextInterface aContext,
				       ContextMementoInterface aMemento) {
	final int theX = aTransformer.applyToX(aGlyph.getOriginX()) - aSize.getUpperLeftX();
	final int theY = aTransformer.applyToY(aGlyph.getOriginY()) - aSize.getUpperLeftY();
	final int theHeight = aSize.getHeight();
	aContext.fillRectangle(theX,theY,2,theHeight);
	aContext.fillRectangle(theX,theY + theHeight - 2,6,2);
    }

    public final static CornerHighlighter INSTANCE = new CornerHighlighter();
    
}
