//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.tutorial;

import java.awt.BorderLayout;
import java.awt.TextArea;
import java.io.StringBufferInputStream;
import java.io.IOException;

import figue.*;

public final class Tutorial_35 extends TutorialApplet {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/tutorial/Tutorial_35.java,v $ $revision$ $Date: 1998/11/02 15:55:58 $ Copyright 1998 INRIA.";

    private final String _input = 
"<?XML version=\"1.0\"?>" + 
"<Facade>" + 
"<Resources>" + 
"<Fonts>" + 
"<Font Name=\"big font\" Family=\"COURIER\" Style=\"Bold\" Size=\"36\" Underlined=\"false\"/>" + 
"</Fonts>" + 
"<Colors>" + 
"<Color Name=\"yellow\" Red=\"255\" Green=\"255\" Blue=\"0\"/>" + 
"<Color Name=\"red\" Red=\"255\" Green=\"0\" Blue=\"0\"/>" + 
"</Colors>" + 
"<Styles>" + 
"<Style Name=\"style hot\" Font=\"big font\" Foreground=\"red\" Background=\"yellow\"/>" + 
"</Styles>" + 
"</Resources>" + 
"<Root>" + 
"<H Interword=\"10\">It's a <KeyWord Style=\"style hot\" Text=\"wonderful\"/> life !!</H>" + 
"</Root>" + 
"</Facade>";

    protected final void initTutorial() {
	final int theColumnNumber = 60;
	FacadeInitializer theParameters = getParameters();
	theParameters.setFormattingWidth(theColumnNumber);
	final StringBufferInputStream theInput = new StringBufferInputStream(_input);
	try {
	    _facade = new AWTFacade(theParameters,theInput);
	    setLayout(new BorderLayout());
	    _textArea = new TextArea("",13,51,TextArea.SCROLLBARS_BOTH);
	    _textArea.setFont(new java.awt.Font("Monospaced",java.awt.Font.PLAIN,13));
	    _textArea.setBackground(java.awt.Color.white);
	    _textArea.setColumns(55);
	    _textArea.append(_input);
	    _textArea.setEditable(false);
	    add(BorderLayout.CENTER,_textArea);
	    add(BorderLayout.SOUTH,_facade.getAwtComponent());
	    setDefaultKeyListener(_facade);
	    _facade.buildInit(null);
 	    _facade.buildComplete();
	    validate();
	}
	catch ( antlr.ParserException anException ) {
	    anException.printStackTrace();
	}
	catch ( IOException anException ) {
	    anException.printStackTrace();
	}
    }

    public final void destroy() {
	_facade.disposeWhenInactive();
	_facade = null;
	super.destroy();
    }
  
    private final FacadeInitializer getParameters() {
	FacadeInitializer theParameters = new FacadeInitializer();
	setAppletParameters(theParameters);
	return theParameters;
    }

    private AWTFacade _facade;
    private TextArea _textArea;

}
